"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const melonjs_1 = require("@melonproject/melonjs");
const deploymentContracts_1 = require("../utils/deploymentContracts");
exports.address = address => address;
exports.balance = (account, args, context) => __awaiter(void 0, void 0, void 0, function* () {
    return context.loaders.balanceOf(args.token, account);
});
exports.allowance = (account, args, context) => __awaiter(void 0, void 0, void 0, function* () {
    return context.loaders.allowance(args.token, account, args.spender);
});
exports.fund = (account, _, context) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        const version = deploymentContracts_1.versionContract(context.environment);
        const address = yield version.getManagersToHubs(account, context.block);
        const hub = new melonjs_1.Hub(context.environment, address);
        // Duck typing the hub contract. If we can fetch a creator for the given
        // address, we assume that it's a valida hub address.
        const creator = yield hub.getCreator(context.block);
        return creator && hub;
    }
    catch (e) {
        return null;
    }
});
exports.participation = (account, args, context) => __awaiter(void 0, void 0, void 0, function* () {
    const hub = new melonjs_1.Hub(context.environment, args.address);
    const routes = yield hub.getRoutes(context.block);
    if (!routes.participation) {
        return null;
    }
    const contract = new melonjs_1.Participation(context.environment, routes.participation);
    return [contract, account];
});
exports.shares = (account, args, context) => __awaiter(void 0, void 0, void 0, function* () {
    const hub = new melonjs_1.Hub(context.environment, args.address);
    const routes = yield hub.getRoutes(context.block);
    if (!routes.shares) {
        return null;
    }
    const contract = new melonjs_1.Shares(context.environment, routes.shares);
    return [contract, account];
});
